<?php
/***************************************************************************
 *                                 filelist.php
 *                            -------------------
 *   begin                : 30/10/2008
 *   copyright            : ('C) 2008 phpATM Dev Team
 *   email                : flavaclown.de/contact.php
 *
 *   $Id: filelist.php, v0.1 11/11/2008 22:43 Flava Clown $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License', or
 *   ('at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPATM', true);
$include_location = dirname(__FILE__)."/";
include($include_location.'include/conf.php');
include($include_location.'include/common2.'.$phpExt);
$uploads_folder_name = $include_location.$uploads_folder_name;
$self_url = sprintf('http%s://%s%s',(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == TRUE ? 's': ''), $_SERVER['HTTP_HOST'], $_SERVER['REQUEST_URI']);

// start config part
$direct_download = false; // set this to true if you want that a click on a filename opens the browser download dialog instead of the fileviewer
$show_action = true; // set it to "true" to show the action column or to "false" to don't show it (default "true")
$show_owner  = false; // set it to "true" to show the owner column or to "false" to don't show it (default "false")
// end config part

if (!function_exists('getGetDir'))
{
	function getGetDir($var_name)
	{
		$forbiddendirs = '../';

		if (isset($_GET[$var_name]))
		{ 
			$damnhackers = strpos($_GET[$var_name], $forbiddendirs);
			if($damnhackers !== false)
			{ die("Hacking attempt"); }
			else
			{ return $_GET[$var_name]; }
		}
		else
		{
			$damnhackers = strpos($HTTP_GET_VARS[$var_name], $forbiddendirs);
			if($damnhackers !== false)
			{ die("Hacking attempt"); }
			else
			{ return $HTTP_GET_VARS[$var_name]; }
		}
	}
}

if (!function_exists('allhtmlentities'))
{
	function allhtmlentities($string)
	{
		return preg_replace('/[^\x09\x0A\x0D\x20-\x7F]/e', '"&#".ord($0).";"', $string);
	}
}

// for the mimetype tooltip mod
if (!function_exists('title_mime_type'))
{
	function title_mime_type($filename)
	{
		global $mimetypes;

		reset($mimetypes);
		while (list($key, $value) = each($mimetypes))
		{
			if (eregi($key.'$', $filename))
			{ return $value['title']; }
		}
		return $mimetypes['default']['title'];
	}
}

function split_dir2($directory)
{
	global $uploads_folder_name, $direction, $order;

	$directory = clean_path($directory);
	if (!file_exists("$uploads_folder_name/$directory"))
	{
		$directory = '';
	}

	$arr = explode("/", $directory);

	$address = '';
	$nav="<a href=\"".basename($_SERVER['SCRIPT_FILENAME'])."?direction=$direction&amp;order=$order\">Home</a>";
	foreach ($arr as $value)
	{
		if ($address == '')
		{ $address.="$value"; }
		else
		{ $address.="/$value"; }
		$nav.=" / <a href=\"".basename($_SERVER['SCRIPT_FILENAME'])."?direction=$direction&amp;order=$order&amp;directory=".rawurlencode($address)."\">$value</a>";
	}

	return($nav);
}

function count_file_viewed($filename)
{
	if (file_exists("$filename.vcnt"))
	{
		$fp = fopen("$filename.vcnt",'r');
		$count = fread($fp, 15);
		fclose($fp);
		return $count;
	}
	return 0;
}

//
// Esegue alcune operazioni preliminari prima di leggere
// il contenuto di una directory
//
function init($directory)
{
	global $uploads_folder_name,$direction,$mess,$phpExt,$self_url;

	$direction = ($direction == DIRECTION_UP) ? DIRECTION_DOWN : DIRECTION_UP;

	$current_dir = $uploads_folder_name;
	if ($directory != '')
	{ $current_dir = "$current_dir/$directory"; }

	if (!is_dir($uploads_folder_name))
	{
		echo "
<h2>$mess[196]</h2>
<p><a href=\"".$self_url."\">$mess[29]</a></p>\n";
		exit;
	}

	if (!is_dir($current_dir))
	{
		echo "
<h2>$mess[30]</h2>
<p><a href=\"javascript:window.history.back()\">$mess[29]</a></p>\n";
		exit;
	}

	return $current_dir;
}

//
// Dati l'array dei file nella directory e l'array delle directory
// li unisce in un array unico
//
function assemble_tables($tab1, $tab2)
{
	global $direction;

	$liste = '';

	if (is_array($tab1))
	{
		while (list($cle, $val) = each($tab1))
		{ $liste[$cle] = $val; }
	}

	if (is_array($tab2))
	{
		while (list($cle, $val) = each($tab2))
		{ $liste[$cle] = $val; }
	}

	return $liste;
}

//
// Data una directory ritorna un array contente tutti i file e le directory
// presenti in tale directory secondo criteri ben precisi (ordine, file accettati, etc.)
//
function listing($current_dir)
{
	global $direction, $order, $reserved_files;

	$totalsize = 0;
	$handle = opendir($current_dir);
	$list_dir = '';
	$list_file = '';
	while (false !== ($filename = readdir($handle)))
	{
		if ($filename != '.' && $filename != '..'
			&& !eregi($reserved_files, $filename)
			&& show_hidden_files($filename))
		{
			$filesize=filesize("$current_dir/$filename");
			$totalsize += $filesize;
			if (is_dir("$current_dir/$filename"))
			{
				if($order == 'mod')
				{ $list_dir[$filename] = filemtime("$current_dir/$filename"); }
				else
				{ $list_dir[$filename] = $filename; }
			}
			else
			{
				switch($order)
				{
					case 'taille';
						$list_file[$filename] = $filesize;
						break;
					case 'mod';
						$list_file[$filename] = filemtime("$current_dir/$filename");
						break;
					case 'rating';
						$list_file[$filename] = count_file_download("$current_dir/$filename");
						break;
					default;
						$list_file[$filename] = get_mimetype_img("$current_dir/$filename");
						break;
				}
			}
		}
	}
	closedir($handle);

	if(is_array($list_file))
	{
		switch($order)
		{
			case 'taille':
			case 'rating':
				$direction == DIRECTION_DOWN ? asort($list_file) : arsort($list_file);
				break;
			case 'mod':
				$direction == DIRECTION_DOWN ? arsort($list_file) : asort($list_file);
				break;
			default:
				$direction == DIRECTION_DOWN ? ksort($list_file) : krsort($list_file);
				break;
		}
	}

	if(is_array($list_dir))
	{
		if ($order == "mod")
		{ $direction == DIRECTION_UP ? arsort($list_dir) : asort($list_dir); }
		else
		{ $direction == DIRECTION_UP ? krsort($list_dir) : ksort($list_dir); }
	}

	$liste = assemble_tables($list_dir, $list_file);

	if ($totalsize >= 1073741824)
	{ $totalsize = round($totalsize / 1073741824 * 100) / 100 . " Gb"; }
	elseif ($totalsize >= 1048576)
	{ $totalsize = round($totalsize / 1048576 * 100) / 100 . " Mb"; }
	elseif ($totalsize >= 1024)
	{ $totalsize = round($totalsize / 1024 * 100) / 100 . " Kb"; }
	else
	{ $totalsize = $totalsize . " b"; }

	return array($liste, $totalsize);
}

//
// Stampa la tabella contente i file e le directory trovate nella directory passata
//
function contents_dir($current_dir, $directory)
{
	global $direction,$order,$totalsize,$mess,$include_location,$installurl;
	global $file_out_max_caracters,$phpExt,$hidden_dirs,$showhidden,$reserved_files,$validation_enabled;
	global $comment_max_caracters,$datetimeformat,$timeoffset,$direct_download,$show_action,$show_owner;

	// Read directory
	list($liste, $totalsize) = listing($current_dir);

	if(is_array($liste))
	{
		while (list($filename,$mime) = each($liste))
		{

			$is_dir = is_dir("$current_dir/$filename");
			$filesize = filesize("$current_dir/$filename");
			$filemtime = filemtime("$current_dir/$filename");
			$link_filename = @rawurlencode(basename($filename));
			$link_directory = @rawurlencode($directory);

			if ($is_dir)
			{
				// Non mostro le dir nascoste
				if (eregi($hidden_dirs, $filename) && !$showhidden)
				{ continue; }

				$filenameandpath = basename($_SERVER['SCRIPT_FILENAME'])."?direction=$direction&amp;order=$order&amp;directory=";

				if ($directory != '')
				{ $filenameandpath .= "$link_directory/"; }

				$filenameandpath .= $link_filename;
			}
			else
			{
				$filenameandpath = '';
				if ($directory != '')
				{ $filenameandpath .= "$link_directory/"; }

				$filenameandpath .= $filename;
			}

			// Controllo la validazione del file. Se  una directory non richiede validazione (per ora).
			if ($is_dir)
			{ $filestatus = VALIDATED; }
			else
			{ list($upl_user, $upl_ip, $filestatus, $contents) = get_file_description("$current_dir/$filename", $comment_max_caracters); }

			if (!$validation_enabled || $filestatus == VALIDATED)
			{
				echo "
<tr>
<td class=\"filename\">";
				if ($is_dir)
				{ echo "<img src=\"".$installurl."/images/".get_mimetype_img("$current_dir/$filename")."\" alt=\"\" title=\"$mess[48]\" />\n"; }
				else
				{ echo "<img src=\"".$installurl."/images/".get_mimetype_img("$current_dir/$filename")."\" alt=\"\" title=\"".title_mime_type("$current_dir/$filename")."\" />\n"; }
				if ($is_dir)
				{ echo " <a href=\"$filenameandpath\" title=\"".allhtmlentities($filename)."\">"; }
				else
				{
					if (!$direct_download && is_viewable($filename))
					{ echo " <a href=\"".$installurl."/index.${phpExt}?action=view&amp;filename=$link_filename&amp;directory=$link_directory\" target=\"_blank\" onclick=\"popup('$filename','$directory'); return false\" title=\"".allhtmlentities($filename)."\">"; }
					elseif ($direct_download)
					{ echo " <a href=\"".$installurl."/index.${phpExt}?action=downloadfile&amp;filename=$link_filename&amp;directory=$link_directory\" title=\"".allhtmlentities($filename)."\">"; }
				}
				if ($is_dir)
				{
					echo allhtmlentities(substr($filename,0,$file_out_max_caracters));
					echo "</a>";
				}
				else
				{
					if (strlen(basename($filename)) <= $file_out_max_caracters)
					{ echo allhtmlentities(basename($filename)); }
					else
					{
						$path_parts = pathinfo($filename); // taken from 'functions.php'
						// makes sure that the max characters number is as it's set (number - dot - dot - extension)
						$file_out_max_characters = ($file_out_max_caracters-2) - strlen($path_parts["extension"]);
						// we need the filename without extension to cut only characters from there
						$name_without_extension = str_replace('.$path_parts["extension"]','',$path_parts["basename"]);
						// the second dot means: filename is shorted (shorted_part_of_filename..extension)
						echo allhtmlentities(substr($name_without_extension,0,$file_out_max_characters)."..".$path_parts["extension"]);
					}
					if($direct_download || is_viewable($filename))
					{ echo "</a>"; }
				}
				// Load description
				if (!$is_dir)
//				{ list($upl_user, $upl_ip, $filestatus, $contents) = get_folder_description("$current_dir/$filename/$filename", $comment_max_caracters); }
//				else
				{ list($upl_user, $upl_ip, $filestatus, $contents) = get_file_description("$current_dir/$filename", $comment_max_caracters); }
				if ($contents != '')
				{
					$contents = allhtmlentities($contents);
					echo "\n<br />\n<span class=\"filedescription\">$contents</span>";
				}
				echo "\n</td>\n";
				if ($show_action)
				{
					echo "<td class=\"actions\">";
/*
					// shows the view icon and view counter
					if (is_viewable($filename))
					{
						echo "&nbsp;<a href=\"".$installurl."/index.${phpExt}?action=view&amp;filename=$link_filename&amp;directory=$link_directory\" target=\"_blank\" onclick=\"popup('$filename','$directory'); return false\" title=\"$filename\"><img src=\"$installurl/images/view20.gif\" alt=\"$mess[219]\" title=\"Click here to open the $mess[219]\" width=\"16\" height=\"16\" /></a>";
						echo count_file_viewed("$current_dir/$filename");
					}
					else
					{ echo "&nbsp;<img src=\"".$installurl."/images/empty.gif\" width=\"16\" height=\"16\" alt=\"\" />&nbsp;&nbsp;"; }
*/
					//
					// Mostro l'icona per il download
					//
					if (!$is_dir)
					{
						echo "&nbsp;<a href=\"".$installurl."/index.${phpExt}?action=downloadfile&amp;filename=$link_filename&amp;directory=$link_directory\"><img src=\"$installurl/images/download.gif\" alt=\"$mess[23]\" title=\"Click here to $mess[23]\" width=\"16\" height=\"16\" /></a>";
						echo count_file_download("$current_dir/$filename");
					}
					else
					{ echo "&nbsp;<img src=\"".$installurl."/images/empty.gif\" width=\"16\" height=\"16\" alt=\"\" />&nbsp;&nbsp;"; }
					echo "</td>\n";
				}
				echo "<td class=\"filesize\">";

				if (is_dir("$current_dir/$filename"))
				{ 
					echo "$mess[48]<br />"; // shows the word 'Directory' - remove this line if you don't want it
					$test = "$current_dir/$filename";
					$countfiles = 0;
					$countdirs = 0;
					$size = 0 ;
					$size_1 = 0; // added 29.05.2007
					$dir = opendir($test); 
					while (false !== ($file = readdir($dir))) 
					{ 
						if (!is_dir("$test/$file") && !eregi($reserved_files, $file))
						{
							list(,,$filestatus) = get_file_description("$current_dir/$filename/$file");
							$filesize = filesize("$current_dir/$filename/$file");
							$size += $filesize;
							if (!$validation_enabled || $filestatus == VALIDATED)
							{
								$size_1 += $filesize;
								$countfiles++;
							}
						}
						elseif ('.' != $file && '..' != $file && !eregi($reserved_files, $file))
						{
							list(,,$filestatus) = get_folder_description("$current_dir/$filename/$file", $comment_max_caracters);
							if (!$validation_enabled || $filestatus == VALIDATED)
							{ $countdirs++; }
						}
					}
					closedir($dir);

					if($validation_enabled && $filestatus == UNVALIDATED)
					{ $size = $size_1; }

					if ($size >= 1073741824)
					{ $size = round($size / 1073741824 * 100) / 100 . ' Gb '; }
					elseif ($size >= 1048576)
					{ $size = round($size / 1048576 * 100) / 100 . ' Mb '; }
					elseif ($size >= 1024)
					{ $size = round($size / 1024 * 100) / 100 . ' Kb '; }
					elseif ($size > 0)
					{ $size = $size . ' b '; }
					else 
					{ $size = '-'; }

					if ($countdirs != 0)
					{
						if($countdirs == 1)
						{ echo $countdirs."&nbsp;Dir<br />"; }
						else
						{ echo $countdirs."&nbsp;Dirs<br />"; }
					}

					if (0 != $countfiles)
					{
						if(1 == $countfiles)
						{ echo "&nbsp;$countfiles File"; }
						else
						{ echo "&nbsp;$countfiles Files"; }
					}

					if(0 == $countdirs && 0 == $countfiles)
					{ echo "Empty"; }
				}
				else
				{ echo format_filesize($filesize); }

				echo "
</td>
<td class=\"uploaddate\">";
				$file_modif_time = $filemtime - $timeoffset * 3600;
				echo date($datetimeformat, $file_modif_time);

				echo "</td>\n";
				if ($show_owner)
				{
					echo "<td class=\"fileowner\">";
					if ($upl_user != "")
					{ echo "$upl_user"; }
					echo "</td>\n";
				}
				echo "</tr>";
			}
		}  // list iterator
	}
}

//
// Crea la tabella con elencati i files e le directory
//
function list_dir($directory)
{
	global $mess,$direction,$uploads_folder_name,$installurl;
	global $order,$totalsize,$phpExt,$direct_download,$show_action,$show_owner;

	// Elimino eventuali '..' e '.'
	$directory = clean_path($directory);
	$current_dir = init($directory);
	$link_filename = rawurlencode(basename($filename));
	$link_directory = rawurlencode($directory);
	$filenameandpath = ($directory != '') ? "&amp;directory=".$link_directory : '';
	$colspan = 2;

	if (!$direct_download)
	{
		echo "<script type=\"text/javascript\">
// <![CDATA[
function popup(file, dir) {
file=escape(file);
dir=escape(dir);
var fen=window.open('$installurl/index.${phpExt}?action=view&filename='+file+'&directory='+dir+'','filemanager','status=yes,scrollbars=yes,resizable=yes,width=700,height=550');
}
// ]]>
</script>";
	}
	echo "
<table id=\"filetable\" summary=\"the filetable\">
<tr>
<th id=\"filename\">$mess[15]
<a href=\"".basename($_SERVER['SCRIPT_FILENAME'])."?order=nom&amp;direction=$direction".$filenameandpath."\">\n";
	if ($order=="nom"||$order=="")
	{ echo "<img src=\"$installurl/images/fleche${direction}.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
	else
	{ echo "<img src=\"$installurl/images/fleche.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
	echo "</th>\n";
	if ($show_action)
	{
		echo "<th id=\"actions\">$mess[16]
<a href=\"".basename($_SERVER['SCRIPT_FILENAME'])."?order=rating&amp;direction=$direction".$filenameandpath."\">\n";
		if ($order=="rating")
		{ echo "<img src=\"$installurl/images/fleche${direction}.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
		else
		{ echo "<img src=\"$installurl/images/fleche.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
		echo "</th>\n";
		$colspan++;
	}
	echo "<th id=\"filesize\">$mess[17]
<a href=\"".basename($_SERVER['SCRIPT_FILENAME'])."?order=taille&amp;direction=$direction".$filenameandpath."\">\n";
	if ($order=="taille")
	{ echo "<img src=\"$installurl/images/fleche${direction}.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
	else
	{ echo "<img src=\"$installurl/images/fleche.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
	echo "</th>
<th id=\"uploaddate\">$mess[18]
<a href=\"".basename($_SERVER['SCRIPT_FILENAME'])."?order=mod&amp;direction=$direction".$filenameandpath."\">\n";
	if ($order=="mod")
	{ echo "<img src=\"$installurl/images/fleche${direction}.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
	else
	{ echo "<img src=\"$installurl/images/fleche.gif\" alt=\"$mess[197]\" title=\"$mess[197]\" width=\"10\" height=\"10\" /></a>"; }
	echo "</th>\n";
	if ($show_owner)
	{
		echo "<th id=\"fileowner\">$mess[19]</th>\n";
		$colspan++;
	}
	echo "</tr>";

	$direction = ($direction == DIRECTION_DOWN) ? DIRECTION_UP : DIRECTION_DOWN;
	contents_dir($current_dir, $directory);
	// Do NOT even think about to remove the "powered by phpATM" note!
	// You can hide it with css like .phpatm { visibility: hidden; }
	echo "
<tr>
<td class=\"phpatm\"><a href=\"http://phpatm.org/\" hreflang=\"en\" lang=\"en\" title=\"Powered by PHP Advanced Transfer Manager v".PROGRAM_VERSION."\">Filelist powered by phpATM</a></td>
<td colspan=\"$colspan\" class=\"totalsize\">$mess[43]: $totalsize</td>
</tr>
</table>";
}

//
// Elimina tutti i caratteri potenzialmente pericolosi (definiti in include/conf.php)
// e taglia la stringa sino al numero massimo di caratteri consentiti
//
function normalize_filename($name)
{
	global $file_name_max_caracters, $invalidchars;

	$name = stripslashes($name);

	reset($invalidchars);
	while (list($key, $value) = each($invalidchars))
	{
		$name = str_replace($value, '', $name);
	}

	$name = substr($name, 0, $file_name_max_caracters);
	return $name;
}

//
// Stampa la pagina intera
//
function show_contents()
{
global $current_dir,$directory,$uploads_folder_name,$mess,$direction,$timeoffset;
global $order,$totalsize,$phpExt,$installurl,$max_allowed_filesize;

// Non mostro la barra di navigazione se la directory passata non esiste
// changed by MrScripto?
$directory = clean_path($directory);
if (!file_exists("$uploads_folder_name/$directory"))
{ $directory = ''; }

if ($directory != '' && !$logged_user_name)
{
	$passed_dir = split("/", $directory);
	if($passed_dir[0] == $public_dir)
	{ $directory = $directory; }
}

// Mostro la barra di navigazione
if ($directory != '')
{
	$name = dirname($directory);
	if ($directory == $name || $name == '.')
	{ $name = ''; }

	echo "
<p class=\"foldernav\"><a href=\"".basename($_SERVER['SCRIPT_FILENAME'])."?direction=$direction&amp;order=$order&amp;directory=$name\">
<img src=\"$installurl/images/parent.gif\" width=\"16\" height=\"16\" alt=\"\" title=\"$mess[220]\" />
</a>";
	echo split_dir2("$directory");
	echo "</p>\n";
}

list_dir($directory);
}

//
// Controlla, espandendo i percorsi, che il file risieda all'interno del ramo di upload
// Questo previene tentativi per visualizzare dei file in directory superiori (/users ad esempio)
// Inoltre controlla che il file non sia speciale (.htaccess, .desc, .dlcnt, index.html, etc.)
//
function is_path_safe(&$path, &$filename)
{
	global $uploads_folder_name, $reserved_files;

	$path = clean_path($path);
	$filename = clean_path($filename);

	if (!file_exists("$uploads_folder_name/$path") || eregi($reserved_files, $filename) || !show_hidden_files($filename))
	{ return false; }

	return true;
}

if(isset($_GET['order']) && $_GET['order'] != '')
{ $order = getGetVar('order'); }
else
{ $order = "nom"; }
if(isset($_GET['direction']) && $_GET['direction'] != '')
{ $direction = getGetVar('direction'); }
else
{ $direction = 0; }
if(isset($_GET['directory']) && $_GET['directory'] != '')
{ $directory = getGetDir('directory'); }

show_contents();

?>